import contextlib

import numpy as np


@contextlib.contextmanager
def tmp_seed(seed: int):
    state = np.random.get_state()
    np.random.seed(seed)
    try:
        yield
    finally:
        np.random.set_state(state)